package info.textgrid.middleware;

import java.io.IOException;
import org.elasticsearch.action.get.GetRequest;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.common.Strings;
import org.elasticsearch.search.fetch.subphase.FetchSourceContext;
import info.textgrid.middleware.oaipmh.ListMetadataFormatsType;
import info.textgrid.middleware.oaipmh.MetadataFormatType;
import info.textgrid.middleware.oaipmh.RequestType;

/**
 *
 */
public class MetadataFormatListDeliverer {

  private boolean idExist = true;

  /**
   * 
   */
  public MetadataFormatListDeliverer() {
    //
  }

  /**
   * @param id
   * @return
   */
  public ListMetadataFormatsType setMetadataFormatList(String id) {

    String[] includes = new String[] {TGConstants.URI};
    String[] excludes = Strings.EMPTY_ARRAY;
    FetchSourceContext fetchSourceContext = new FetchSourceContext(true, includes, excludes);

    ListMetadataFormatsType lmft = new ListMetadataFormatsType();
    MetadataFormatType mft = new MetadataFormatType();
    
    GetRequest getRequest = new GetRequest(OAI_ESClient.getEsIndex(), OAI_ESClient.getEsType(), id.replace("textgrid:", ""))
        .fetchSourceContext(fetchSourceContext);
    
    /*
     * GetRequestBuilder recordById = OAI_ESClient.getEsClient().get(getRequest, GetAction.INSTANCE)
     * .setIndex(OAI_ESClient.getEsIndex()) .setType(OAI_ESClient.getEsType())
     * .setFields(TGConstants.URI) .setId(id);
     */

    GetResponse tgObject = null;
    try {
      tgObject = OAI_ESClient.getEsClient().get(getRequest, RequestOptions.DEFAULT);
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }

    if (tgObject.isExists()) {
      setIdExist(true);
      mft.setMetadataPrefix(OAIPMHUtilities.OAIDC_PREFIX);
      mft.setMetadataNamespace(OAIPMHUtilities.OAIDC_NAMESPACE);
      mft.setSchema(OAIPMHUtilities.OAIDC_SCHEMA_LOCATION);
      lmft.getMetadataFormat().add(mft);
    } else {
      setIdExist(false);
      lmft = null;
    }

    return lmft;
  }

  /**
   * @return
   */
  public ListMetadataFormatsType setMetadataFormatListWithoutId() {

    ListMetadataFormatsType lmft = new ListMetadataFormatsType();
    MetadataFormatType mft = new MetadataFormatType();
    MetadataFormatType mftIdiomMets = new MetadataFormatType();

    mft.setMetadataPrefix(OAIPMHUtilities.OAIDC_PREFIX);
    mft.setMetadataNamespace(OAIPMHUtilities.OAIDC_NAMESPACE);
    mft.setSchema(OAIPMHUtilities.OAIDC_SCHEMA_LOCATION);
    lmft.getMetadataFormat().add(mft);

    mftIdiomMets.setMetadataPrefix(TGConstants.METADATA_IDIOM_PREFIX);
    mftIdiomMets.setMetadataNamespace(OAIPMHUtilities.METS_NAMESPACE);
    mftIdiomMets.setSchema(OAIPMHUtilities.METS_SCHEMA_LOCATION);
    lmft.getMetadataFormat().add(mftIdiomMets);

    return lmft;
  }

  /**
   * @param request
   * @return
   */
  public boolean requestChecker(RequestType request) {

    boolean requestCheck = true;

    if (request.getFrom() != null
        || request.getMetadataPrefix() != null
        || request.getResumptionToken() != null) {
      requestCheck = false;
    } else if (request.getSet() != null ||
        request.getUntil() != null) {
      requestCheck = false;
    }

    return requestCheck;
  }

  /**
   * @return
   */
  public boolean isIdExist() {
    return this.idExist;
  }

  /**
   * @param idExist
   */
  public void setIdExist(boolean idExist) {
    this.idExist = idExist;
  }

}
